//检查ip白名单
const arg = require('../plug-in/arg');
const checkIp = require('../plug-in/checkClientIp');
const {server} = require('../plug-in/fk2Path');
const serverToken = require('../plug-in/serverToken');
const readJSON = require('../plug-in/readJSON');
const serverCode = require('../plug-in/serverCode');
var rest = {code:0,msg:'An unknown error'};
const arr = ['/code'] //不存在域名时，需要通过ip白名单的url
module.exports = async (req, res,site) => {
    const obj = arg(req);
    const {protocol} = req;
    if (site[obj.headers.host]) {
        // 存在域名时
        if(!site[obj.headers.host][protocol]){
            // 没有开启协议
            res.json(rest)
        }else{
            // 开启协议
            
        }
    } else {
        // 不存在域名时
        // console.log(obj.ip);
        if(arr.includes(obj.url)){
            // 存在url时验证ip白名单
            if(!checkIp(obj.ip)){
                // 没通过白名单
                rest.msg = "IP does not exist!"
                res.json(rest);
                return
            }
        }
        // 验证token
        const {key,secret} = readJSON(server);
        const code = serverCode(key,secret);
        if(code==null){
            res.json(rest);
            return
        }
        var data = obj.data;
        const md5 = obj.data.md5;
        delete data.md5;
        const token = serverToken(code,data);
        if(md5!==token){
            res.json(rest);
            return
        }
        try {
            const {main} = require('./api'+obj.url);
            res.json(await main(obj));
        } catch (e) {
            res.json(rest);
        }
    }
}